"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registerCodePushWrapperWith = registerCodePushWrapperWith;
exports.syncWithCodePush = syncWithCodePush;

var _reactNativeCodePush = _interopRequireDefault(require("react-native-code-push"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 配置 CodePush 为手动检查更新
 */
const codePushOptions = {
  checkFrequency: _reactNativeCodePush.default.CheckFrequency.MANUAL
};
/**
 * you should wrapper your intro component with this function
 * @param component
 */

function registerCodePushWrapperWith(component) {
  return (0, _reactNativeCodePush.default)(codePushOptions)(component);
}
/**
 * you can call this function to check if there have any update in CodePush server and download it
 * downloaded bundle will be auto-install when you launch application next time
 */


function syncWithCodePush() {
  _reactNativeCodePush.default.sync({
    installMode: _reactNativeCodePush.default.InstallMode.ON_NEXT_RESTART
  }).then(value => {
    console.log('code push sync state : ' + value.valueOf());
  });
}
//# sourceMappingURL=codepushHook.js.map