"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.customParser = exports.UpdateStateType = void 0;

var _information = require("./information");

var _initializer = require("./initializer");

let UpdateStateType;
/**
 * parse json data to useful information
 * @param json data fetched from xupdate service
 */

exports.UpdateStateType = UpdateStateType;

(function (UpdateStateType) {
  UpdateStateType[UpdateStateType["NO_NEW_VERSION"] = 0] = "NO_NEW_VERSION";
  UpdateStateType[UpdateStateType["HAVE_NEW_VERSION"] = 1] = "HAVE_NEW_VERSION";
  UpdateStateType[UpdateStateType["HAVE_NEW_VERSION_FORCE_UPDATE"] = 2] = "HAVE_NEW_VERSION_FORCE_UPDATE";
})(UpdateStateType || (exports.UpdateStateType = UpdateStateType = {}));

const customParser = json => {
  /**
   * backend result name of apk file , use this function generate entire url
   * @param downloadUrl
   */
  function generateUpdateApplicationDownloadUrl(downloadUrl) {
    if (_information.xupdateInitParamsRef === null) {
      throw _initializer.notInitializeError;
    }

    return _information.xupdateInitParamsRef.updateServiceHost + 'update/apk/' + downloadUrl;
  }

  let appInfo = JSON.parse(json);
  console.log('receive application update information : ' + JSON.stringify(appInfo.data));

  if (appInfo.data['updateStatus'] === UpdateStateType.NO_NEW_VERSION.valueOf()) {
    return {
      //必填
      hasUpdate: false,
      versionCode: 999,
      versionName: 'fuck the update',
      updateContent: 'fuck the update , because he force me fill these content.',
      downloadUrl: 'fuck the update apk'
    };
  } //if state have version , represent should update


  let hasUpdate = appInfo.data['updateStatus'] !== UpdateStateType.NO_NEW_VERSION.valueOf();
  let isForce = appInfo.data['updateStatus'] === UpdateStateType.HAVE_NEW_VERSION_FORCE_UPDATE.valueOf(); //always disable ignore feature , because if ignore the version ,  check update will not trigger window display

  let isIgnorable = false;
  let versionCode = appInfo.data['versionCode'];
  let versionName = appInfo.data['versionName'];
  let updateContent = appInfo.data['modifyContent'].replace('\\\\r\\\\n', '\r\n');
  let downloadUrl = appInfo.data['downloadUrl'];
  let apkSize = appInfo.data['apkSize'];
  let apkMd5 = appInfo.data['apkMd5'];
  return {
    //必填
    hasUpdate: hasUpdate,
    versionCode: versionCode,
    versionName: versionName,
    updateContent: updateContent,
    downloadUrl: generateUpdateApplicationDownloadUrl(downloadUrl),
    //选填
    isForce: isForce,
    isIgnorable: isIgnorable,
    apkSize: apkSize,
    apkMd5: apkMd5
  };
};

exports.customParser = customParser;
//# sourceMappingURL=parser.js.map