/**
 * result information of ios update check
 */
export declare type IosUpdateCheckResult = {
    shouldUpdate: boolean;
    version?: string;
    releaseNote?: string;
    trackViewUrl?: string;
};
export declare type IosCheckUpdateParams = {
    /**
     * ios application unique identification
     */
    iosBundleId: string;
    /**
     * current version of your application
     */
    iosVersion: string;
};
/**
 * you can call this function to check ios update
 * @param params see {@link IosCheckUpdateParams}
 */
export declare const checkIosUpdate: (params: IosCheckUpdateParams) => Promise<IosUpdateCheckResult>;
