import type { OriginXupdateInitialParams } from './information';
export declare const notInitializeError: Error;
/**
 * you can call this function to inject service address and other information when xupdate init successful
 * @param params see {@link OriginXupdateInitialParams}
 */
declare function injectXupdateParams(params: OriginXupdateInitialParams): void;
/**
 * call this function to init Xupdate framework
 * @param takeOverInitializeCallback if you pass this callback , you need manager initialize state by your self
 * so you can gain full control of initialize state
 */
declare function initXupdateFramework(takeOverInitializeCallback?: (success: boolean) => void): void;
export { injectXupdateParams, initXupdateFramework };
