/**
 * query whether this application have new version
 * this operation not execute by xupdate framework , so the Error listener will never be triggered
 */
export declare function queryHasUpdate(): Promise<boolean>;
/**
 * call this function to launch check update process
 * if have newer version in service , the application will display dialog to let user update
 * if you want to deal the circumstance that not have newer version in service , call {@link injectNoUpdateListener}
 */
export declare function displayUpdateDialogIfHaveUpdate(): void;
export declare type ErrorListener = (message: string) => void;
/**
 * in some circumstance , you may want to notice user there not have an update
 * you can use this method to inject a listener.
 * notice : listener only can be use once
 * @param purpose why you want to listen the no-update-error
 * @param listener action will be execute when there not have update in server
 */
export declare function injectNoUpdateListener(purpose: string, listener: ErrorListener): void;
